import Taro, { Component } from '@tarojs/taro'
import echart from '../ec-canvas/echarts'

function initChart(callback) {
  return function (canvas, width, height) {
    const chart = echarts.init(canvas, null, {
      width: width,
      height: height
    });
    canvas.setChart(chart);
    callback && callback(chart);
    return chart;
  }
}

export default class LineChart extends Component {
  config = {
    usingComponents: {
      "ec-canvas": "../ec-canvas/ec-canvas"
    }
  }

  // this.echart
  echart = null

  state = {
    ec: { onInit: initChart(this.handleChart.bind(this)) },
    loading: false,
  }

  componentWillMount() {

  }

  handleChart (chart) {
    this.echart = chart
    if (!this.props.source) {
      this.setState({ loading: true })
      this.echart.showLoading()
    } else {
      this.refreshChart()
    }
  }

  refreshChart() {
    const defaultOpt = {
      color: ['#BB9C79', '#666666'],
      tooltip: {},
      xAxis: {type: 'category'},
      yAxis: {},
      dataset: {},
      series: [],
    }

    const options = {
      ...defaultOpt,
      dataset: { source: this.props.source },
      series: {
        type: 'line',
        dimensions: [ 'item' ],
      },
    }

    this.echart.setOption(options)
    this.echart.hideLoading()
  }

  render() {
    <ec-canvas id="mychart-dom-line" canvas-id="mychart-line" ec={this.state.ec}></ec-canvas>
  }
}
