import Taro, { Component } from '@tarojs/taro';
import Authorize from '@components/authorize'
import { View } from "@tarojs/components";
import './index.scss'
import { AtTabs, AtTabsPane, AtProgress } from 'taro-ui'
import "taro-ui/dist/style/components/tabs.scss"
import "taro-ui/dist/style/components/progress.scss";
import { savePoint, updatePoint } from '@services/common'
import { querySexInfo } from '@services/person'
import { connect } from '@tarojs/redux'
import PieChart from "../../../components/PieChart";


@connect(({ user, city }) => ({ user, city }))
export default class analysis extends Taro.Component {

  config = {
    navigationBarTitleText: ''
  }

  state = {
    current: 0,
    recordId: undefined, // 埋点ID
    sexInfo: [],
  }

  componentWillUnmount() {
    const { recordId } = this.state
    recordId && updatePoint(recordId)
  }

  handleClick(value) {
    if (value == '0') {
      querySexInfo('new').then(res => {
        this.setState({
          sexInfo: res || []
        })
      })
    } else if (value == '1') {
      querySexInfo('follow').then(res => {
        this.setState({
          sexInfo: res || []
        })
      })
    } else {
      querySexInfo('visite ').then(res => {
        this.setState({
          sexInfo: res || []
        })
      })
    }

    this.setState({
      current: value
    })

  }

  componentDidMount() {
    querySexInfo('new').then(res => {
      this.setState({
        sexInfo: res || []
      })
    })
    const chartData = [
      { value: 335, name: '直接访问' },
      { value: 310, name: '邮件营销' },
      { value: 234, name: '联盟广告' },
      { value: 135, name: '视频广告' },
      { value: 1548, name: '搜索引擎' }
    ];
    this.pieChart.refresh(chartData);
  }
  refPieChart = (node) => this.pieChart = node

  render() {

    const tabList = [{ title: '新增客户' }, { title: '跟进客户' }, { title: '到访客户' }]
    const { sexInfo } = this.state

    return (
      <View>
        <AtTabs className="tab-bar" current={this.state.current} tabList={tabList} onClick={this.handleClick.bind(this)}>
          <AtTabsPane current={this.state.current} index={0} >
            <View>
              <PieChart ref={this.refPieChart} />
              <View style="height:20rpx;background:#f5f5f5;"> </View>
              <View style="padding: 40rpx;">
                <View style="font-size: 36rpx;color: #666;margin-bottom:20rpx;">性别</View>
                {
                  sexInfo.map(item => (
                    <View style="display: flex;align-items: center;"><View style="font-size: 32rpx;color: #666;min-width:80rpx">{item.genderType == 1 ? '男' : item.genderType == 2 ? '女' : '未知'}</View><AtProgress percent={(item.percentage * 100).toFixed(2)} strokeWidth={6} color={item.genderType == 1 ? '#BB9C79' : item.genderType == 2 ? '#F6B61D' : '#A2A2A2'} /></View>
                  ))
                }
              </View>
            </View>
          </AtTabsPane>
          <AtTabsPane current={this.state.current} index={1}>
          <View>
              <PieChart ref={this.refPieChart} />
              <View style="height:20rpx;background:#f5f5f5;"> </View>
              <View style="padding: 40rpx;">
                <View style="font-size: 36rpx;color: #666;margin-bottom:20rpx;">性别</View>
                {
                  sexInfo.map(item => (
                    <View style="display: flex;align-items: center;"><View style="font-size: 32rpx;color: #666;min-width:80rpx">{item.genderType == 1 ? '男' : item.genderType == 2 ? '女' : '未知'}</View><AtProgress percent={(item.percentage * 100).toFixed(2)} strokeWidth={6} color={item.genderType == 1 ? '#BB9C79' : item.genderType == 2 ? '#F6B61D' : '#A2A2A2'} /></View>
                  ))
                }
              </View>
            </View>
          </AtTabsPane>
          <AtTabsPane current={this.state.current} index={2}>
          <View>
              <PieChart ref={this.refPieChart} />
              <View style="height:20rpx;background:#f5f5f5;"> </View>
              <View style="padding: 40rpx;">
                <View style="font-size: 36rpx;color: #666;margin-bottom:20rpx;">性别</View>
                {
                  sexInfo.map(item => (
                    <View style="display: flex;align-items: center;"><View style="font-size: 32rpx;color: #666;min-width:80rpx">{item.genderType == 1 ? '男' : item.genderType == 2 ? '女' : '未知'}</View><AtProgress percent={(item.percentage * 100).toFixed(2)} strokeWidth={6} color={item.genderType == 1 ? '#BB9C79' : item.genderType == 2 ? '#F6B61D' : '#A2A2A2'} /></View>
                  ))
                }
              </View>
            </View>
          </AtTabsPane>
        </AtTabs>
      </View>
    )
  }
}